/*!
 * Ninja Popups for WordPress
 * http://codecanyon.net/item/ninja-popups-for-wordpress/3476479?ref=arscode
 *
 * Copyright 2014, ARSCode
 */
function snp_ga(category, action, label, value)
{
    if(!snp_enable_analytics_events	|| typeof ga !== "function")
    {
		return;
    }
    ga('send', 'event', category, action, label, value);
}
function snp_set_cookie(name,value,expires)
{
	if(expires==-2)
	{
	    return
	}
	if(expires!=-1)
	{
		expires=expires*1;
		var args = {path: '/', expires: expires};
	}
	else
	{
		var args = {path: '/'};
	}
	if (!snp_ignore_cookies)
	{
		jQuery.cookie(name, value, args);
	}
}
function snp_close()
{
    if(jQuery.fancybox2!==undefined && jQuery.fancybox2.isOpen)
    {
	jQuery.fancybox2.close();
    }
    else
    {
	var popup=jQuery('#snp_popup').val();
	if(snp_f[popup+'-open']!==undefined)
	{
	    snp_f[popup+'-close']();
	    snp_onclose_popup();
	}
    }
}
function snp_onsubmit(form)
{
	var popup=jQuery('#snp_popup').val();
	var popup_ID=parseInt(jQuery('#snp_popup_id').val());
	if(!popup_ID)
	{
		popup_ID=form.parents('.snppopup').find('.snp_popup_id').val();
	}
	var ab_ID=form.parents('.snppopup').find('.snp_popup_ab_id').val();
	if(ab_ID === undefined)
	{
	   ab_ID = false;
	}
	var snp_optin_redirect_url=form.parents('.snppopup').find('.snp_optin_redirect_url').val();
	if(form.attr('action')=='#')
	{
		var submit_button = jQuery(":submit",form);
		var submit_button_width = jQuery(":submit",form).outerWidth();
		var text_loading = submit_button.data('loading');
		var text_success = submit_button.data('success');
		var nextstep = submit_button.data('nextstep');
		var text_submit = submit_button.text() ? submit_button.text() : submit_button.val();
		if(text_loading)
		{
		    if(!submit_button.hasClass('snp-nomw'))
		    {
			submit_button.css('min-width',submit_button_width);
		    }
		    submit_button.text(text_loading);
		    submit_button.val(text_loading);
		}
		data = {};
		data['action'] = 'snp_popup_submit';
		data['popup_ID'] = popup_ID;
		jQuery('input, select, textarea', form).each(function(key) 
		{
			data[this.name] = this.value;
		});
		jQuery.ajax({
			url: snp_ajax_url, 
			type: 'POST',
			dataType: 'json',
			data: data, 
			success: function(data){
				jQuery("input",form).removeClass('snp-error');
				if(data.Ok==true)
				{
					snp_onconvert('optin',popup_ID, ab_ID, (!nextstep ? true : false));
					if(snp_optin_redirect_url)
					{
						document.location.href=snp_optin_redirect_url;
					}
					if(nextstep)
					{
					    var p=submit_button.parents('.snp-fb');
					    p.find('.snp-step-show').fadeOut(function(){jQuery(this).removeClass('snp-step-show');p.find('.snp-step-'+nextstep).fadeIn(function(){jQuery(this).addClass('snp-step-show');});});
					}
					else if(text_success)
					{
					    submit_button.text(text_success);
					    submit_button.val(text_success);
					    setTimeout("snp_close();", 800);
					}
					else
					{
					    snp_close();
					}
				}
				else
				{
					if(data.Errors)
					{
						jQuery.each(data.Errors, function(index, value) { 
							jQuery("input[name='"+index+"']",form).addClass('snp-error');
						});	
					}
					if(text_loading)
					{
					    submit_button.text(text_submit);
					    submit_button.val(text_submit);
					}
				}
			}
		});
		return false;
	}
	else
	{
		var Error=0;
		jQuery('input[type="text"]', form).each(function(key) 
		{
			if(!this.value)
			{
				Error=1;
				jQuery(this).addClass('snp-error');
			}
			else
			{
				jQuery(this).removeClass('snp-error');
			}
		});
		if(Error==1)
		{
			return false;
		}
		if(form.attr('target')=='_blank')
		{
			snp_close();
		}
		if(snp_optin_redirect_url)
		{
			document.location.href=snp_optin_redirect_url;
		}
		snp_onconvert('optin',popup_ID, ab_ID);
		return true;
	}
}
function snp_onconvert(type, popup_ID, ab_ID, close)
{
	var popup=jQuery('#snp_popup').val();
	if(!popup_ID)
	{
		var popup_ID=parseInt(jQuery('#snp_popup_id').val());
	}
	if(popup)
	{
		var cookie_conversion=jQuery('#'+popup+' .snp_cookie_conversion').val();
		if(!cookie_conversion)
		{
			cookie_conversion=30;
		}
		snp_set_cookie('snp_'+popup, '1',cookie_conversion);
	}
	jQuery.post(
	snp_ajax_url, 
	{
		'action': 'snp_popup_stats',
		'type': type,
		'popup_ID' : popup_ID,
		'ab_ID' : ab_ID
	});
	if(type!='optin')
	{
		var snp_optin_redirect_url=jQuery('#'+popup).find('.snp_optin_redirect_url').val();
		if(snp_optin_redirect_url)
		{
			document.location.href=snp_optin_redirect_url;
		}
	}
	snp_ga('popup', 'subscribe', popup_ID);
	if(close==true)
	{
	    snp_close();
	}
}
function snp_onshare_li()
{
	snp_onconvert('li',0,false,true);
}
function snp_onshare_gp()
{
	snp_onconvert('gp',0,false,true);
}
function snp_onclose_popup()
{
	var popup=jQuery('#snp_popup').val();
	if(jQuery('#snp_popup').val())
	{
	    var cookie_close=jQuery('#'+jQuery('#snp_popup').val()+' .snp_cookie_close').val();
	}
	else
	{
	    cookie_close=-1;
	}
	if(!jQuery.cookie('snp_'+popup))
	{
		if(!cookie_close)
		{
			cookie_close=-1;	
		}
		snp_set_cookie('snp_'+popup, '1', cookie_close);
	}
	if(jQuery('#snp_exithref').val())
	{
		// exit popup
		//if(jQuery('#snp_exittarget').val()=='_blank')
		//{
		//	window.open(jQuery('#snp_exithref').val());	
		//}
		//else
		//{
		document.location.href=jQuery('#snp_exithref').val();
		//}
	}
	jQuery('.fancybox-overlay').removeClass('snp-pop-'+jQuery('#snp_popup_id').val()+'-overlay');
	jQuery('.snp-wrap').removeClass('snp-pop-'+jQuery('#snp_popup_id').val()+'-wrap');
	jQuery('#snp_popup_theme').val('');
	jQuery('#snp_popup').val('');
	jQuery('#snp_popup_id').val('');
	jQuery('#snp_exithref').val('');
	jQuery('#snp_exittarget').val('');
}
function snp_onstart_popup()
{
	jQuery('.fancybox-overlay').addClass('snp-pop-'+jQuery('#snp_popup_id').val()+'-overlay');
	jQuery('.snp-wrap').addClass('snp-pop-'+jQuery('#snp_popup_id').val()+'-wrap');
	jQuery('.snp-wrap').addClass('snp-pop-'+jQuery('#snp_popup_theme').val()+'-wrap');
	var ab_ID = jQuery('.snp-pop-'+jQuery('#snp_popup_id').val()).find('.snp_popup_ab_id').val();
	if(ab_ID === undefined)
	{
	   ab_ID = false;
	}
	jQuery.post(
	snp_ajax_url, 
	{
		'action': 'snp_popup_stats',
		'type': 'view',
		'popup_ID' : jQuery('#snp_popup_id').val(),
		'ab_ID' : ab_ID,
	});
}
function snp_open_popup(href,target,popup,type)
{
	if(jQuery.fancybox2!==undefined && jQuery.fancybox2.isOpen)
	{
		return;
	}
	if (snp_enable_mobile==false && type!='content' && jQuery.browser.mobile==true)
	{
	    return;
	}
	if (snp_ignore_cookies || type=='content')
	{
	}
	else
	{
		if(jQuery.cookie('snp_'+popup)==1){return true;}
	}
	var snp_autoclose=parseInt(jQuery('#'+popup+' .snp_autoclose').val());
	var snp_show_cb_button=jQuery('#'+popup+' .snp_show_cb_button').val();
	if(snp_autoclose)
	{
		snp_timer=setTimeout("snp_close()",snp_autoclose*1000);
		jQuery('#'+popup+' input').focus(function() {clearTimeout(snp_timer);});
	}
	var snp_overlay=jQuery('#'+popup+' .snp_overlay').val();
	jQuery('#snp_popup').val(popup);
	jQuery('#snp_popup_id').val(jQuery('#'+popup+' >  .snp_popup_id').val());
	jQuery('#snp_popup_theme').val(jQuery('#'+popup+' >  .snp_popup_theme').val());
	jQuery('#snp_exithref').val(href);
	jQuery('#snp_exittarget').val(target);
	snp_ga('popup', 'open', jQuery('#snp_popup_id').val());
	if(snp_f[popup+'-open']!==undefined)
	{
	    jQuery('#'+popup).appendTo("body");
	    snp_f[popup+'-open']();
	    snp_onstart_popup();
	}
	else
	{
	    var overlay_css = {};
	    if(snp_overlay=='disabled')
	    {	
		    overlay_css.background='none';
	    }
	    jQuery.fancybox2({
		    'href' : '#'+popup,
		    'helpers': {
			    'overlay' : {
				    'locked' : false,
				    'closeClick' : false,
				    'showEarly' : false,
				    'speedOut'   : 5,
				    'css' : overlay_css
			    }
		    },
		    'padding': 0,
		    'autoCenter' : jQuery.browser.mobile==true ? false : true,
		    'autoDimensions' : true,
		    'titleShow' : false,
		    //'openEffect': 'none',
		    'closeBtn' : (snp_show_cb_button=='yes' ? true : false),
		    'keys' : {
			    'close'  : (snp_show_cb_button=='yes' ? [27] : '')
		    },
		    'showNavArrows' : false,
		    'wrapCSS' : 'snp-wrap',
		    'afterClose' : function (){return snp_onclose_popup()},
		    'beforeShow' : function (){return snp_onstart_popup()}
	    });
	}
	if(jQuery('#'+popup+' .snp-subscribe-social').length>0)
	{
		if (typeof FB != 'undefined') {
			FB.Event.subscribe('edge.create',function() {
				snp_onconvert('fb',0,false,true);
			});
		}
		if (typeof twttr != 'undefined') {
			twttr.events.bind('tweet', function(event) {
				snp_onconvert('tw_t',0,false,true);
			});
			twttr.events.bind('follow', function(event) {
				snp_onconvert('tw_f',0,false,true);
			});
		}
		jQuery("#"+popup+" a.pin-it-button").click(function(){
			snp_onconvert('pi',0,false,true);
		});
	}
	return false;
}
jQuery(document).ready(function($){
   jQuery('.snp-submit').click(function(){
	$(this).blur();
    });
    jQuery('.snp_nextstep').click(function(){
	var nextstep=$(this).data('nextstep');
	var p=$(this).parents('.snp-fb');
	p.find('.snp-step-show').fadeOut(function(){jQuery(this).removeClass('snp-step-show');p.find('.snp-step-'+nextstep).fadeIn(function(){jQuery(this).addClass('snp-step-show');})});
	snp_ga('popup', 'step' + nextstep, jQuery('#snp_popup_id').val());
	return false;
    });
});
(function(a){(jQuery.browser=jQuery.browser||{}).mobile=/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))})(navigator.userAgent||navigator.vendor||window.opera);